import { Injector, OnDestroy } from '@angular/core';
import { BaseEntityFeatureFactory, EntityFeatureFactory } from '../model';
import { TraitEffect } from '../trait-effect';
import * as i0 from "@angular/core";
export declare function buildLocalTraits<State, F extends EntityFeatureFactory<any, any, State, any, any>>(injector: Injector, componentName: string, traitFactory: F, loadEntitiesEffectFactory?: TraitLocalEffectsFactory<F>): {
    destroy: () => void;
} & ReturnType<F>;
export interface Type<T> extends Function {
    new (...args: any[]): T;
}
export interface TraitLocalEffectsFactory<F extends BaseEntityFeatureFactory<any, any, any>> {
    (allActions: ReturnType<F>['actions'], allSelectors: ReturnType<F>['selectors']): Type<TraitEffect>;
}
export interface LocalTraitsConfig<F extends BaseEntityFeatureFactory<any, any, any>> {
    componentName: string;
    traitsFactory: F;
    effectFactory?: TraitLocalEffectsFactory<F>;
}
export declare abstract class TraitsLocalStore<F extends BaseEntityFeatureFactory<any, any, any>> extends TraitEffect implements OnDestroy {
    injector: Injector;
    traits: ReturnType<F> & {
        destroy: () => void;
    };
    actions: ReturnType<F>['actions'];
    selectors: ReturnType<F>['selectors'];
    constructor(injector: Injector);
    abstract setup(): LocalTraitsConfig<F>;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TraitsLocalStore<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TraitsLocalStore<any>>;
}
